## connectome-workbench 1.2.3+git41-gc4c6c90

=== debian/changelog ===
connectome-workbench (1.2.3+git41-gc4c6c90-2) unstable; urgency=medium

  * Upload of the snapshot from experimental to unstable
  * d/p/changeset_cf1faad575229c6519aee2b773f3e50b3d89e17e.diff
    to resolve FTBFS with gcc 7 (Closes: #853354)

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 08 Aug 2017 00:00:21 -0400

connectome-workbench (1.2.3+git41-gc4c6c90-1) experimental; urgency=medium

  * Upstream "experimental" snapshot in attempt to resolve FTBFS on mips,
    mipsel due to heavy memory resource demand -- some files were moved
    around and possibly split.
  * debian/patches -- dropped all (all adopted upstream)

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 19 Oct 2016 19:32:58 -0400

=== debian/control ===
Source: connectome-workbench
Section: science
Priority: extra
Maintainer: NeuroDebian Team <team@neuro.debian.net>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>, Michael Hanke <michael.hanke@gmail.com>
Build-Depends: debhelper (>= 9),
               help2man, cmake,
               libosmesa6-dev,
               libqt4-dev,
               libssl-dev, zlib1g-dev,
               libqt4-opengl-dev | libqt4-dev (<< 4.4.0),
               libglib2.0-dev,
               xauth, xvfb,
               libftgl-dev,
Standards-Version: 3.9.8
Homepage: http://www.nitrc.org/projects/workbench/
Vcs-Git: git://github.com/neurodebian/workbench -b debian
Vcs-Browser: http://github.com/neurodebian/workbench

Package: connectome-workbench
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: caret
Suggests: ffmpeg
Description: brain visualization, analysis and discovery tool
 Connectome Workbench is a brain visualization, analysis and discovery
 tool for fMRI and dMRI brain imaging data, including functional and
 structural connectivity data generated by the Human Connectome
 Project.
 .
 Package includes wb_command, a command-line program for performing a
 variety of analytical tasks for volume, surface, and CIFTI
 grayordinates data.

Package: connectome-workbench-dbg
Architecture: any
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends},
         connectome-workbench (= ${binary:Version})
Description: brain visualization, analysis and discovery tool -- debug symbols
 Connectome Workbench is a brain visualization, analysis and discovery
 tool for fMRI and dMRI brain imaging data, including functional and
 structural connectivity data generated by the Human Connectome
 Project.
 .
 Package includes wb_command, a command-line program for performing a
 variety of analytical tasks for volume, surface, and CIFTI
 grayordinates data.
 .
 This package contains debug symbols for the binaries.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

srcpkg = $(shell LC_ALL=C dpkg-parsechangelog | grep '^Source:' | cut -d ' ' -f 2,2)
debver = $(shell LC_ALL=C dpkg-parsechangelog | grep '^Version:' | cut -d ' ' -f 2,2 )
uver = $(shell echo $(debver) | cut -d '-' -f 1,1 )
parallel=$(shell dpkg --print-architecture | grep -q mips && echo '' || echo '--parallel')

export  http_proxy=http://127.0.0.1:9/
export  https_proxy=http://127.0.0.1:9/

# export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
    export CFLAGS += -O0
else
    export CFLAGS += -O2
endif

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export DEB_CFLAGS_MAINT_APPEND = -DNDEBUG
export DEB_CXXFLAGS_MAINT_APPEND = -DNDEBUG

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# Default mega-rule
%:
	dh $@ $(parallel) --sourcedirectory=src

override_dh_clean:
	cat src/debian/copyright debian/copyright.debian >| debian/copyright
	# Bring shipped version back
	[ -e src/FtglFont.aside ] && mv src/FtglFont.aside src/FtglFont || :
	dh_clean

override_dh_auto_configure:
	# Just to make sure we are not using shipped version
	[ -e src/FtglFont ] && mv src/FtglFont src/FtglFont.aside || [ -e src/FtglFont.aside ]
	OSMESA_DIR=/usr \
     dh_auto_configure -- \
		-DCMAKE_SKIP_RPATH:BOOL=OFF
#-DBUILD_SHARED_LIBS:BOOL=ON

override_dh_auto_install:
	dh_auto_install

	: # Sloppy man pages for now. Improve with templates
	mkdir -p debian/tmp/usr/share/man/man1
	help2man --no-info --help-option=-help --version-string=$(uver) \
		-n "visualization and discovery tool used to map neuroimaging data" \
		debian/tmp/usr/bin/wb_view \
		>| debian/tmp/usr/share/man/man1/wb_view.1

	help2man --no-info --help-option=-all-commands-help --version-string=$(uver) \
		-n "command-line program for performing a variety of algorithmic tasks using volume, surface, and grayordinate data" \
		debian/tmp/usr/bin/wb_command \
		>| debian/tmp/usr/share/man/man1/wb_command.1

override_dh_install:
	dh_install
	install -D -m 0644 icons/linux/workbench_128x128x32.png debian/connectome-workbench/usr/share/pixmaps/connectome-workbench.png

override_dh_strip:
	dh_strip --dbg-package=connectome-workbench-dbg

## connectome-workbench 1.3.0

=== src/CMakeLists.txt ===
#
# Minimum required version of CMAKE
#
CMAKE_MINIMUM_REQUIRED (VERSION 2.8)

#
# Set to true for verbose output when debugging this file
#
SET(WB_CMAKE_VERBOSE_OUTPUT_FLAG TRUE)

##########################################################################################
#
# A function to get all user defined variables with a specified prefix
# From https://cmake.org/Wiki/CMake/Tutorials/SettingVariableGroups
#
function (getListOfVarsStartingWith _prefix _varResult)
    get_cmake_property(_vars CACHE_VARIABLES)
    string (REGEX MATCHALL "(^|;)${_prefix}[A-Za-z0-9_]*" _matchedVars "${_vars}")
    set (${_varResult} ${_matchedVars} PARENT_SCOPE)
endfunction()


##########################################################################################
#
# Workbench CACHE variables
# TSC: use "CACHE <type> <docstring>" syntax in SET commands so they can be overridden by cmake options
#
set (WORKBENCH_QT5_DISABLE_DEPRECATED FALSE CACHE BOOL 
     "If TRUE, use of Qt 5 deprecated functionality will cause compiler to fail")
set (WORKBENCH_USE_CMAKE_AUTOMOC FALSE CACHE BOOL 
     "If TRUE, use CMAKE_AUTOMOC command for generating 'moc' files")
set (WORKBENCH_USE_QT5 TRUE CACHE BOOL 
     "If TRUE, require Qt5, else Qt4.<NEWLINE>Specify as argument to cmake: -DWORKBENCH_USE_QT5=TRUE")
set (WORKBENCH_USE_QT5_QOPENGL_WIDGET FALSE CACHE BOOL 
     "With Qt5, QOpenGLWidget instead of deprecated QGLWidget")
set (WORKBENCH_MESA_DIR "" CACHE PATH 
     "Directory containing Mesa's 'include' and 'lib' <NEWLINE>directories.  Mesa is optional and used by <NEWLINE>wb_command's -show-scene operation.")

##########################################################################################
#
# Setting the compiler MUST be done before the PROJECT
# statement or else an infinite loop will occur indicating
# that the compiler has been redefined.
#
IF(APPLE)
    ADD_DEFINITIONS(-DCARET_OS_MACOSX)
ELSEIF(UNIX)
    IF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
        ADD_DEFINITIONS(-DCARET_OS_LINUX)
        SET(CMAKE_POSITION_INDEPENDENT_CODE ON)
    ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
ELSEIF(WIN32)
    ADD_DEFINITIONS(-DCARET_OS_WINDOWS)
    # Policy CMP0020 is related to Qt
    # https://cmake.org/cmake/help/v3.5/policy/CMP0020.html
    if(POLICY CMP0020) 
        cmake_policy(SET CMP0020 NEW)
    endif()
    IF(MSVC)
        ADD_DEFINITIONS(-DCARET_OS_WINDOWS_MSVC)
            ADD_DEFINITIONS(-D_USE_MATH_DEFINES -DNOMINMAX)
            SET( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -MP -wd4290 -wd4244 -wd4267 -wd4305 -wd4100 -wd4005" )
        IF(CMAKE_CL_64)
        ELSE()
        ENDIF(CMAKE_CL_64)
    ELSE(MSVC)
    ENDIF(MSVC)
ELSE(APPLE)
    MESSAGE(SEND_ERROR "Unrecognized operating system " ${CMAKE_SYSTEM_NAME})
ENDIF(APPLE)

#
# Intel compiler
#
IF (${CMAKE_CXX_COMPILER} MATCHES "^.*icpc$")
    ADD_DEFINITIONS("-W -Wall -Werror=return-type -Werror=switch -Wunused-parameter")
ENDIF (${CMAKE_CXX_COMPILER} MATCHES "^.*icpc$")

#
# Clang compiler on Mac
#
UNSET(CLANG_FLAG)
IF (${CMAKE_CXX_COMPILER} MATCHES "^.*clang\\+\\+.*")
    SET(CLANG_FLAG TRUE)
ENDIF (${CMAKE_CXX_COMPILER} MATCHES "^.*clang\\+\\+.*")
IF (${CMAKE_CXX_COMPILER} MATCHES "^.*clang2\\+\\+.*")
    SET(CLANG_FLAG TRUE)
ENDIF (${CMAKE_CXX_COMPILER} MATCHES "^.*clang2\\+\\+.*")
IF (CLANG_FLAG)
    ADD_DEFINITIONS("-W -Wall -Werror=return-type -Werror=switch -Wunused-parameter -Wno-deprecated-declarations")
ENDIF (CLANG_FLAG)


#
# IF GNU compiler, functions without a return type or switch
# statements that do not handle all of the enumerated types
# are treated as an error.  Also, all warnings.
#
IF (NOT MSVC)
    if (CMAKE_COMPILER_IS_GNUCC)
        execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion
                        OUTPUT_VARIABLE GCC_VERSION)
        message("gcc version is: " ${GCC_VERSION})
        if(${GCC_VERSION} VERSION_LESS "4.2")
            ADD_DEFINITIONS(-W -Wall)
        else()
            ADD_DEFINITIONS(-W -Wall -Werror=return-type -Werror=switch -Wunused-parameter)
        endif()

        if (${GCC_VERSION} VERSION_LESS "4.9")
            # there is no greater than or equal in CMake
        else()
            ADD_DEFINITIONS(-Wno-narrowing -Wno-unused-local-typedefs)
        endif()
    endif()
ENDIF (NOT MSVC)

##########################################################################################
#
# If GNU compiler, use SIMD-based dot computation, if possible
#
SET(SIMD_RESULT "Search for SIMD disabled for compiler on this system.")
if (CMAKE_COMPILER_IS_GNUCC OR CLANG_FLAG)
    #
    # Define flag to avoid trying to compile SIMD stuff (coded for x86 only)
    #
    SET(WORKBENCH_USE_SIMD TRUE CACHE BOOL "try to compile with SIMD support")

    #
    # If we should try to use SIMD, check whether cpuinfo compiles
    #
    IF (WORKBENCH_USE_SIMD)
        TRY_COMPILE(CPUINFO_COMPILES ${CMAKE_CURRENT_BINARY_DIR}/cpuinfo_compile_test ${CMAKE_CURRENT_SOURCE_DIR}/kloewe/cpuinfo cpuinfo)
        
        #
        # Add the necessary definition and include directory to enable the 
        # SIMD-based dot product implementations
        #
        IF (CPUINFO_COMPILES)
            ADD_DEFINITIONS(-DCARET_DOTFCN)
            INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/kloewe/dot/src)
            SET(SIMD_RESULT "Enabled")
        ELSE()
            SET(SIMD_RESULT "Failed when compiling with SIMD")
        ENDIF()
    ELSE (WORKBENCH_USE_SIMD)
        SET(SIMD_RESULT "Search for SIMD disabled, WORKBENCH_USE_SIMD=FALSE")
    ENDIF (WORKBENCH_USE_SIMD)
endif(CMAKE_COMPILER_IS_GNUCC OR CLANG_FLAG)

#TSC: we require c++11, so it needs to be in the compile flags - in older cmake, this needs to be done manually
IF (${CMAKE_VERSION} VERSION_LESS "3.1")
    IF (CMAKE_COMPILER_IS_GNUCC)
        include(CheckCXXCompilerFlag)
        CHECK_CXX_COMPILER_FLAG("-std=c++11" GCC_STD11)
        IF (${GCC_STD11})
            SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
        ELSE (${GCC_STD11})
            SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
        ENDIF (${GCC_STD11})
    ENDIF (CMAKE_COMPILER_IS_GNUCC)
ELSE (${CMAKE_VERSION} VERSION_LESS "3.1")
    SET(CMAKE_CXX_STANDARD 11)
    SET(CMAKE_CXX_STANDARD_REQUIRED TRUE)
ENDIF (${CMAKE_VERSION} VERSION_LESS "3.1")

##########################################################################################
#
# OpenSSL
#
SET(OPENSSL_RESULT "Not Found")
FIND_PACKAGE(OpenSSL)
IF(OPENSSL_FOUND)
    INCLUDE_DIRECTORIES(${OPENSSL_INCLUDE_DIR})
    SET(OPENSSL_RESULT "${OPENSSL_VERSION}   ${OPENSSL_LIBRARIES}")
ELSE (OPENSSL_FOUND)
    MESSAGE("OpenSSL NOT FOUND.  May need to define OPENSSL_ROOT_DIR when running CMake.")
    MESSAGE("   cmake -DOPENSSL_ROOT_DIR=<path> \n")
    MESSAGE("See: https://cmake.org/cmake/help/v3.5/module/FindOpenSSL.html")
ENDIF(OPENSSL_FOUND)

##########################################################################################
#
# Must have QT 4.8 or QT 5, recommended 5.6 or later
# https://cmake.org/cmake/help/v3.5/manual/cmake-packages.7.html#manual:cmake-packages(7)
# Modules List: http://doc.qt.io/qt-5/qtmodules.html
#
SET(QT_RESULT "Not Found")
SET(CARET_QT5_LINK "")
IF (WORKBENCH_USE_QT5) 
    #
    # The OpenGL module is deprecated in Qt5 and 
    # is needed only if QGLWidget is used for
    # the OpenGL graphics.
    #
    IF (NOT WORKBENCH_USE_QT5_QOPENGL_WIDGET)
        SET(WB_QT_OPENGL_MODULE "OpenGL")
    ENDIF ()

    FIND_PACKAGE(Qt5 REQUIRED COMPONENTS Concurrent Core Gui Network ${WB_QT_OPENGL_MODULE} PrintSupport Test Widgets Xml)
    IF (WORKBENCH_USE_QT5_QOPENGL_WIDGET)
        #
        # QGLWidget is deprecated in Qt 5 and is replaced with QOpenGLWidget
        #
        # If WORKBENCH_USE_QT5_QOPENGL_WIDGET is defined, QOpenGLWidget is used
        # for OpenGL.  Otherwise, QGLWidget is used.
        #
        add_definitions(-DWORKBENCH_USE_QT5_QOPENGL_WIDGET)
    ELSE (WORKBENCH_USE_QT5_QOPENGL_WIDGET)
        remove_definitions(-DWORKBENCH_USE_QT5_QOPENGL_WIDGET)
    ENDIF (WORKBENCH_USE_QT5_QOPENGL_WIDGET)

    IF (WORKBENCH_QT5_DISABLE_DEPRECATED)
        # Causes Qt to remove declarations for deprecated functionality
        add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0x050700) 
        # Enable usage of replacements for Qt deprecated functionality in Workbench source code
        add_definitions(-DWORKBENCH_REPLACE_QT_DEPRECATED)
    ENDIF (WORKBENCH_QT5_DISABLE_DEPRECATED)

    #small hack to get the qt5 compile flag requirements into libraries
    SET(CARET_QT5_LINK "Qt5::Core")

    SET(QT_RESULT "${Qt5_VERSION}")
ELSE ()
    FIND_PACKAGE(Qt4 4.8 REQUIRED)
    IF(QT4_FOUND)
        INCLUDE(${QT_USE_FILE})
        SET(QT_RESULT "${QTVERSION}")
    ELSE(QT4_FOUND)
        MESSAGE(SEND_ERROR "QT4 not found")
    ENDIF(QT4_FOUND)
ENDIF ()

##########################################################################################
#
# Try to find Qwt, otherwise use bundle
#
SET(QWT_RESULT "Not Found")
IF (NOT WIN32)
    PKG_CHECK_MODULES(Qwt qwt)
ENDIF (NOT WIN32)
IF (Qwt_FOUND)
    SET(QWT_RESULT "Using Qwt Library ${Qwt_LIBRARIES}")
ELSE (Qwt_FOUND)
    SET(QWT_RESULT "In Workbench Source Code")
ENDIF (Qwt_FOUND)

##########################################################################################
#
# Need OpenGL
#
SET(OPENGL_RESULT "")
FIND_PACKAGE(OpenGL REQUIRED)
IF (OPENGL_FOUND)
    #
    # Need help finding includes on Apple
    #
    IF (APPLE)
        # When searching for the include directory, find the location
        # for the OpenGL framework rather than an individual header file.
        FIND_PATH(OPENGL_INCLUDE_DIR OpenGL.framework
                  /System/Library/Frameworks
                  /Library/Frameworks
                  ~/Library/Frameworks)
    ENDIF (APPLE)
    #
    # OpenGL Include Directory
    #
    INCLUDE_DIRECTORIES(${OPENGL_INCLUDE_DIR})
    MESSAGE("OpenGL Include Directory: ${OPENGL_INCLUDE_DIR}")
    MESSAGE("OpenGL Libraries: ${OPENGL_LIBRARIES}")
    SET(OPENGL_RESULT ${OPENGL_LIBRARIES})
ELSE (OPENGL_FOUND)
    MESSAGE(SEND_ERROR "OpenGL Libraries were not found")
ENDIF (OPENGL_FOUND)

##########################################################################################
#
# Look for GLEW but only on Windows
#
SET(GLEW_RESULT "No")
IF (WIN32)
    FIND_PACKAGE(GLEW)
ENDIF ()

IF (GLEW_FOUND)
    SET(GLEW_RESULT "${GLEW_INCLUDE_DIRS} ${GLEW_LIBRARIES}")
    MESSAGE("GLEW Include Dirs: ${GLEW_INCLUDE_DIRS}")
    MESSAGE("GLEW Libraries: ${GLEW_LIBRARIES}")
    STRING(FIND ${GLEW_LIBRARIES} "glew32s.lib" GLEW_STATIC_LIB_NAME_INDEX)
    ADD_DEFINITIONS(-DHAVE_GLEW)
    IF (GLEW_STATIC_LIB_NAME_INDEX GREATER -1)
        ADD_DEFINITIONS(-DHAVE_GLEW_STATIC_LIB)
        MESSAGE("GLEW Static Library Found")
    ENDIF()
    INCLUDE_DIRECTORIES(${GLEW_INCLUDE_DIRS})
ELSE()
    SET(GLEW_LIBRARIES "")
    SET(GLEW_INCLUDE_DIRS "")
    IF (WIN32)
        MESSAGE(SEND_ERROR "GLEW not found and is required on Windows for finding OpenGL functions.\n"
                           "    Setting CMAKE_PREFIX_PATH to the GLEW installation directory when\n"
                           "    running CMAKE may help find GLEW.\n")
    ENDIF()
ENDIF()

##########################################################################################
#
# The Find OpenMP package may not work on all systems and the user may
# furnish the paths to the OpenMP files by using environment variables.
#
# The environment variables are:
#    OPENMP_COMPILE_OPTION=-fopenmp
#    OPENMP_HEADER_DIR=/usr/local/clang-openmp-opt/llvm/build/Release/include
#    OPENMP_LIB_DIR=/usr/local/clang-openmp-opt/llvm/build/Release/lib
#
UNSET(OPENMP_FOUND)
IF (EXISTS $ENV{OPENMP_HEADER_DIR})
    MESSAGE("OpenMP Header File:  $ENV{OPENMP_HEADER_DIR}")
    IF (EXISTS $ENV{OPENMP_LIB_DIR})
        MESSAGE("OpenMP Library File: $ENV{OPENMP_LIB_DIR}")
        SET (STUFF $ENV{OPENMP_COMPILE_OPTION})
        IF (DEFINED STUFF)
            MESSAGE("OpenMP Compiler Option: $ENV{OPENMP_COMPILE_OPTION}")

=== src/CommandLine/CMakeLists.txt ===

#
# Name of project
#
PROJECT (CommandLine)

#cmake_policy(SET CMP0015 OLD) 


#
# Add QT for includes
#
if(Qt5_FOUND)
    include_directories(${Qt5Core_INCLUDE_DIRS})
#    include_directories(${Qt5Network_INCLUDE_DIRS})
endif()
IF (QT4_FOUND)
    SET(QT_USE_QTXML TRUE)
    SET(QT_USE_QTNETWORK TRUE)
    INCLUDE(${QT_USE_FILE})
ENDIF ()

#
# Name of executable
#
set (EXE_NAME wb_command)

#
# Resources
#
SET (RESOURCES_QRC_FILE ../Resources/General/general_resources.qrc)
IF (Qt5_FOUND)
    QT5_ADD_RESOURCES(IMAGE_RCS_SRCS ${RESOURCES_QRC_FILE})
ELSE (Qt5_FOUND)
    IF (QT4_FOUND)
        QT4_ADD_RESOURCES(IMAGE_RCS_SRCS ${RESOURCES_QRC_FILE})
    ENDIF()
ENDIF (Qt5_FOUND)

#
# Create the executable
# Apple creates a bundle
#
IF (APPLE)
   ADD_EXECUTABLE(${EXE_NAME}
      MACOSX_BUNDLE
      wb_command.cxx
      ${IMAGE_RCS_SRCS}
   )
ELSE (APPLE)
   ADD_EXECUTABLE(${EXE_NAME}
      wb_command.cxx
      ${IMAGE_RCS_SRCS}
   )
ENDIF (APPLE)


if(Qt5_FOUND)
    set(QT5_LINK_LIBS
        Qt5::Concurrent
        Qt5::Core
        Qt5::Gui
        Qt5::Network
#        Qt5::OpenGL
#        Qt5::PrintSupport
        Qt5::Test
#        Qt5::Widgets
        Qt5::Xml)
endif()

SET (MESA_OR_OPENGL_LIBRARIES "")
IF (OSMESA_FOUND)
    SET(MESA_OR_OPENGL_LIBRARIES
        ${OSMESA_OFFSCREEN_LIBRARY}
        ${OSMESA_GL_LIBRARY}
        ${OSMESA_GLU_LIBRARY})
ELSE()
    IF (OPENGL_FOUND)
        SET(MESA_OR_OPENGL_LIBRARIES ${OPENGL_LIBRARIES})
    ELSE()
        MESSAGE(SEND_ERROR "Must have either OpenGL or Mesa3D for command line")
    ENDIF()
ENDIF()

#
# Libraries that are linked
# Note: GLEW_LIBRARIES and OSMESA library variables will be empty and
# have no effect if not available
#
TARGET_LINK_LIBRARIES(${EXE_NAME}
Commands
Operations
Algorithms
OperationsBase
Brain
Files
Graphics
${FTGL_LIBRARIES}
Annotations
Palette
Gifti
Cifti
Nifti
Charting
FilesBase
Scenes
Xml
Common
${QUAZIP_LIBRARIES}
${FREETYPE_LIBRARIES}
${QT_LIBRARIES}
${QT5_LINK_LIBS}
${GLEW_LIBRARIES}
${MESA_OR_OPENGL_LIBRARIES}
${ZLIB_LIBRARIES}
${LIBS})

INCLUDE(GNUInstallDirs)

INSTALL(TARGETS ${EXE_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})
INSTALL(PROGRAMS wb_shortcuts DESTINATION ${CMAKE_INSTALL_BINDIR})
INSTALL(FILES bashcomplete_wb_command DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/bash-completion/completions RENAME wb_command)

#
# Find Headers
#
INCLUDE_DIRECTORIES(
${CMAKE_SOURCE_DIR}/CommandLine
${CMAKE_SOURCE_DIR}/Commands
${CMAKE_SOURCE_DIR}/Operations
${CMAKE_SOURCE_DIR}/Algorithms
${CMAKE_SOURCE_DIR}/Annotations
${CMAKE_SOURCE_DIR}/OperationsBase
${CMAKE_SOURCE_DIR}/Brain
${CMAKE_SOURCE_DIR}/Charting
${CMAKE_SOURCE_DIR}/Palette
${CMAKE_SOURCE_DIR}/Files
${CMAKE_SOURCE_DIR}/Gifti
${CMAKE_SOURCE_DIR}/Cifti
${CMAKE_SOURCE_DIR}/Nifti
${CMAKE_SOURCE_DIR}/FilesBase
${CMAKE_SOURCE_DIR}/Scenes
${CMAKE_SOURCE_DIR}/Xml
${CMAKE_SOURCE_DIR}/Common
${QUAZIP_INCLUDE_DIRS}
)

=== src/GuiQt/CMakeLists.txt ===

#
# Name of project
#
PROJECT (GuiQt)

#
# QT include files
#
if(Qt5_FOUND)
    include_directories(${Qt5Core_INCLUDE_DIRS})
    include_directories(${Qt5OpenGL_INCLUDE_DIRS})
    include_directories(${Qt5Network_INCLUDE_DIRS})
    include_directories(${Qt5Widgets_INCLUDE_DIRS})
endif()
IF (QT4_FOUND)
    SET(QT_USE_QTNETWORK TRUE)
    SET(QT_USE_QTOPENGL TRUE)
    INCLUDE(${QT_USE_FILE})
ENDIF ()

#
# Let CMake find files for moc and uic.
#

#
# With AUTOMOC, do not need to specify files
# that contain Q_OBJECT macro for Qt to process with 'moc'
# (meta-object compiler).
#
IF(WORKBENCH_USE_CMAKE_AUTOMOC)
    SET(CMAKE_AUTOMOC ON)
    SET(CMAKE_AUTOUIC ON)
ELSE()
    SET(FORMS
        MovieDialog.ui
       )

    SET(MOC_INPUT_HEADER_FILES
        AboutWorkbenchDialog.h
        AnnotationChangeCoordinateDialog.h
        AnnotationColorWidget.h
        AnnotationCoordinateSelectionWidget.h
        AnnotationCoordinateSpaceWidget.h
        AnnotationCoordinateWidget.h
        AnnotationCreateDialog.h
        AnnotationDeleteWidget.h
        AnnotationFontWidget.h
        AnnotationFormatWidget.h
        AnnotationInsertNewWidget.h
        AnnotationLineArrowTipsWidget.h
        AnnotationMenuArrange.h
        AnnotationMenuFileSelection.h
        AnnotationRedoUndoWidget.h
        AnnotationRotationWidget.h
        AnnotationSelectionViewController.h
        AnnotationPasteDialog.h
        AnnotationTextAlignmentWidget.h
        AnnotationTextEditorDialog.h
        AnnotationTextEditorWidget.h
        AnnotationTextOrientationWidget.h
        AnnotationWidthHeightWidget.h
        BalsaDatabaseUploadSceneFileDialog.h
        BalsaStudySelectionDialog.h
        BorderEditingSelectionDialog.h
        BorderFileSplitDialog.h
        BorderOptimizeDialog.h
        BorderPropertiesEditorDialog.h
        BorderSelectionViewController.h
        BrainBrowserWindow.h
        BrainBrowserWindowComboBox.h
        BrainBrowserWindowOrientedToolBox.h
        BrainBrowserWindowToolBar.h
        BrainBrowserWindowToolBarChartAttributes.h
        BrainBrowserWindowToolBarChartAxes.h
        BrainBrowserWindowToolBarChartTwoAttributes.h
        BrainBrowserWindowToolBarChartTwoAxes.h
        BrainBrowserWindowToolBarChartTwoOrientation.h
        BrainBrowserWindowToolBarChartTwoTitle.h
        BrainBrowserWindowToolBarChartTwoType.h
        BrainBrowserWindowToolBarChartType.h
        BrainBrowserWindowToolBarClipping.h
        BrainBrowserWindowToolBarComponent.h
        BrainBrowserWindowToolBarSlicePlane.h
        BrainBrowserWindowToolBarSliceSelection.h
        BrainBrowserWindowToolBarSurfaceMontage.h
        BrainBrowserWindowToolBarTab.h
        BrainBrowserWindowToolBarTabPopUpMenu.h
        BrainBrowserWindowToolBarVolumeMontage.h
        BrainOpenGLWidget.h
        BugReportDialog.h
        CaretColorEnumComboBox.h
        CaretColorEnumMenu.h
        CaretDataFileSelectionComboBox.h
        CaretFileDialog.h
        CaretFileDialogExtendable.h
        CaretFileRemoteDialog.h
        CaretMappableDataFileAndMapSelector.h
        CaretMappableDataFileAndMapSelectorObject.h
        ChartHistoryViewController.h
        ChartLinesSelectionViewController.h
        ChartMatrixParcelSelectionViewController.h
        ChartMatrixSeriesSelectionViewController.h
        ChartTwoOverlaySetViewController.h
        ChartTwoOverlayViewController.h
        ChartSelectionViewController.h
        ChartToolBoxViewController.h
        CiftiConnectivityMatrixViewController.h
        CiftiParcelSelectionComboBox.h
        ClippingPlanesDialog.h
        ColorEditorWidget.h
	CopyPaletteColorMappingToFilesDialog.h
        CustomViewDialog.h
        DataFileContentCopyMoveDialog.h
        DisplayGroupAndTabItemViewController.h
        DisplayGroupEnumComboBox.h
        EnumComboBoxTemplate.h
        FiberOrientationSelectionViewController.h
        FiberSamplesOpenGLWidget.h
        FociProjectionDialog.h
        FociPropertiesEditorDialog.h
        FociSelectionViewController.h
        GapsAndMarginsDialog.h
        GiftiLabelTableEditor.h
        GiftiLabelTableSelectionComboBox.h
        GroupAndNameHierarchyViewController.h
        GuiManager.h
        HelpViewerDialog.h
        HyperLinkTextBrowser.h
        IdentifyBrainordinateDialog.h
        ImageCaptureDialog.h
        ImageFileConvertToVolumeFileDialog.h
        ImageSelectionViewController.h
        InformationDisplayDialog.h
        InformationDisplayPropertiesDialog.h
        LabelSelectionViewController.h
	LockAspectWarningDialog.h
        MacApplication.h
        MacDockMenu.h
        MapSettingsChartTwoLineHistoryWidget.h
	MapSettingsColorBarPaletteOptionsWidget.h
        MapSettingsColorBarWidget.h
        MapSettingsFiberTrajectoryWidget.h
        MapSettingsLabelsWidget.h
        MapSettingsLayerWidget.h
        MapSettingsPaletteColorMappingWidget.h
        MapSettingsParcelsWidget.h
        MapYokingGroupComboBox.h
        MetaDataEditorDialog.h
        MetaDataEditorWidget.h
        MovieDialog.h
	OffScreenOpenGLRenderer.h
        OverlaySetViewController.h
        OverlaySettingsEditorDialog.h
        OverlayViewController.h
        PaletteColorMappingEditorDialog.h
        PlotMagnifier.h
        PlotPanner.h
        PreferencesDialog.h
        ProgressReportingDialog.h
        ProgressReportingFromEvent.h
        ProgressReportingWithSlots.h
        RegionOfInterestCreateFromBorderDialog.h
        SceneBasePathWidget.h
        SceneCreateReplaceDialog.h
        SceneDialog.h
        ScenePreviewDialog.h
        SceneShowOptionsDialog.h
        SpecFileManagementDialog.h
        SplashScreen.h
        StructureEnumComboBox.h
        StructureSurfaceSelectionControl.h
        SurfacePropertiesEditorDialog.h
        SurfaceSelectionViewController.h
	ThresholdingSetMapsDialog.h
        TileTabsConfigurationDialog.h
        UserInputModeAnnotationsContextMenu.h
        UserInputModeAnnotationsWidget.h
        UserInputModeBordersWidget.h
        UserInputModeFociWidget.h
        UserInputModeImageWidget.h
        UserInputModeViewContextMenu.h
        UserInputModeVolumeEditWidget.h
        UserInputTileTabsContextMenu.h
        UsernamePasswordWidget.h
        VolumeFileCreateDialog.h
        VolumeSurfaceOutlineColorOrTabViewController.h
        VolumeSurfaceOutlineSetViewController.h
        VolumeSurfaceOutlineViewController.h
        WuQCollapsibleWidget.h
        WuQDataEntryDialog.h
        WuQDialog.h
        WuQDialogModal.h
        WuQDialogNonModal.h
        WuQDoubleSlider.h
        WuQDoubleSpinBox.h
        WuQEventBlockingFilter.h
        WuQGridLayoutGroup.h
        WuQGroupBoxExclusiveWidget.h
        WuQImageLabel.h
        WuQListWidget.h
        WuQMessageBox.h
        WuQwtPlot.h
        WuQSpecialIncrementDoubleSpinBox.h
        WuQSpinBoxGroup.h
        WuQSpinBoxOddValue.h
        WuQTabWidget.h
	WuQTextEditorDialog.h
        WuQTimedMessageDisplay.h
        WuQTreeWidget.h
        WuQTrueFalseComboBox.h
        #WuQWebView.h
        WuQWidget.h
        WuQWidgetObjectGroup.h
        ZipSceneFileDialog.h
    )

    IF(Qt5_FOUND)
        QT5_WRAP_CPP(MOC_SOURCE_FILES ${MOC_INPUT_HEADER_FILES})
        QT5_WRAP_UI(FORMS_HEADERS ${FORMS})
    ENDIF()
    IF (QT4_FOUND)
        QT4_WRAP_CPP(MOC_SOURCE_FILES ${MOC_INPUT_HEADER_FILES})
        QT4_WRAP_UI(FORMS_HEADERS ${FORMS})
    ENDIF ()
ENDIF()

#
# Header files
#
SET(SOURCE_FILES
AboutWorkbenchDialog.h
AnnotationChangeCoordinateDialog.h
AnnotationColorWidget.h
AnnotationCoordinateInformation.h
AnnotationCoordinateSelectionWidget.h
AnnotationCoordinateSpaceWidget.h
AnnotationCoordinateWidget.h
AnnotationCreateDialog.h
AnnotationDeleteWidget.h
AnnotationFontWidget.h
AnnotationFormatWidget.h
AnnotationInsertNewWidget.h
AnnotationLineArrowTipsWidget.h
AnnotationMenuArrange.h
AnnotationMenuFileSelection.h
AnnotationPasteDialog.h
AnnotationRedoUndoWidget.h
AnnotationRotationWidget.h
AnnotationSelectionViewController.h
AnnotationTextAlignmentWidget.h
AnnotationTextEditorDialog.h
AnnotationTextEditorWidget.h
AnnotationTextOrientationWidget.h
AnnotationWidgetParentEnum.h
AnnotationWidthHeightWidget.h
BalsaDatabaseManager.h
BalsaDatabaseUploadSceneFileDialog.h
BalsaStudySelectionDialog.h
BalsaStudyInformation.h
BalsaUserRoles.h
BorderEditingSelectionDialog.h
BorderFileSplitDialog.h
BorderOptimizeDialog.h
BorderOptimizeExecutor.h
BorderPropertiesEditorDialog.h
BorderSelectionViewController.h
BrainBrowserWindow.h
BrainBrowserWindowComboBox.h
BrainBrowserWindowEditMenuItemEnum.h
BrainBrowserWindowOrientedToolBox.h
BrainBrowserWindowToolBar.h
BrainBrowserWindowToolBarChartAttributes.h
BrainBrowserWindowToolBarChartAxes.h
BrainBrowserWindowToolBarChartTwoAttributes.h
BrainBrowserWindowToolBarChartTwoAxes.h
BrainBrowserWindowToolBarChartTwoOrientation.h
BrainBrowserWindowToolBarChartTwoTitle.h
BrainBrowserWindowToolBarChartTwoType.h
BrainBrowserWindowToolBarChartType.h
BrainBrowserWindowToolBarClipping.h
BrainBrowserWindowToolBarComponent.h
BrainBrowserWindowToolBarSlicePlane.h
BrainBrowserWindowToolBarSliceSelection.h
BrainBrowserWindowToolBarSurfaceMontage.h
BrainBrowserWindowToolBarTab.h
BrainBrowserWindowToolBarTabPopUpMenu.h
BrainBrowserWindowToolBarVolumeMontage.h
BrainOpenGLWidget.h
BugReportDialog.h
CaretColorEnumComboBox.h
CaretColorEnumMenu.h
CaretDataFileSelectionComboBox.h
CaretFileDialog.h
CaretFileDialogExtendable.h
CaretFileRemoteDialog.h
CaretMappableDataFileAndMapSelector.h
CaretMappableDataFileAndMapSelectorObject.h
ChartHistoryViewController.h
ChartLinesSelectionViewController.h
ChartMatrixParcelSelectionViewController.h
ChartMatrixSeriesSelectionViewController.h
ChartTwoOverlaySetViewController.h
ChartTwoOverlayViewController.h
ChartSelectionViewController.h
ChartToolBoxViewController.h
CiftiConnectivityMatrixViewController.h
CiftiParcelSelectionComboBox.h
ClippingPlanesDialog.h
ColorEditorWidget.h
CopyPaletteColorMappingToFilesDialog.h
CursorDisplayScoped.h
CursorEnum.h
CursorManager.h
CustomViewDialog.h
DataFileContentCopyMoveDialog.h
DisplayGroupAndTabItemTreeWidgetItem.h
DisplayGroupAndTabItemViewController.h
DisplayGroupEnumComboBox.h
EnumComboBoxTemplate.h
EventAnnotationCreateNewType.h
EventAnnotationGetDrawnInWindow.h
EventBrowserWindowDrawingContent.h
EventBrowserWindowCreateTabs.h
EventBrowserWindowGraphicsRedrawn.h
EventBrowserWindowNew.h
EventBrowserWindowTileTabOperation.h
EventGetOrSetUserInputModeProcessor.h
EventGraphicsUpdateAllWindows.h
EventGraphicsUpdateOneWindow.h
EventHelpViewerDisplay.h
EventIdentificationRequest.h
EventImageCapture.h
EventMacDockMenuUpdate.h
EventOperatingSystemRequestOpenDataFile.h
EventOverlaySettingsEditorDialogRequest.h
EventPaletteColorMappingEditorDialogRequest.h
EventShowDataFileReadWarningsDialog.h
EventUpdateInformationWindows.h
EventUpdateVolumeEditingToolBar.h
EventUpdateYokedWindows.h
EventUserInterfaceUpdate.h
FiberOrientationSelectionViewController.h
FiberSamplesOpenGLWidget.h
FociProjectionDialog.h
FociPropertiesEditorDialog.h
FociSelectionViewController.h
GapsAndMarginsDialog.h
GiftiLabelTableEditor.h
GiftiLabelTableSelectionComboBox.h
GroupAndNameHierarchyTreeWidgetItem.h
GroupAndNameHierarchyViewController.h
GuiManager.h
HelpViewerDialog.h
HyperLinkTextBrowser.h
IdentifyBrainordinateDialog.h
ImageCaptureDialog.h
ImageFileConvertToVolumeFileDialog.h
ImageSelectionViewController.h
InformationDisplayDialog.h
InformationDisplayPropertiesDialog.h
KeyEvent.h
LabelSelectionViewController.h
LockAspectWarningDialog.h
MacApplication.h
MacDockMenu.h
MapSettingsChartTwoLineHistoryWidget.h
MapSettingsColorBarPaletteOptionsWidget.h
MapSettingsColorBarWidget.h
MapSettingsFiberTrajectoryWidget.h
MapSettingsLabelsWidget.h
MapSettingsLayerWidget.h
MapSettingsPaletteColorMappingWidget.h
MapSettingsParcelsWidget.h
MapYokingGroupComboBox.h
MetaDataEditorDialog.h
MetaDataEditorWidget.h
MouseEvent.h
MovieDialog.h
OffScreenOpenGLRenderer.h
OverlaySetViewController.h
OverlaySettingsEditorDialog.h
OverlayViewController.h
